!ALL LINES WITH ! ARE DEP, 3/25/82 TO FIRST_FLAG THE INITS
! THAT IS,TO HAVE IMPLIED OPEN ON ANY INDIVIDUAL UNIT
C
C	FORTRAN SIMULATION OF VERSATEC - MTAPE SUBROUTINE
C
C	SUBROUTINE MTAPE(IUNIT,ICTL,IERR,KNT,IBUF,IAMT)
C
C	IUNIT - SELECT DRIVE
C		0 - MTA0:
C		1 - MTB0:
C		2 - MTB1:
C	ICTL - CONTROL FUNCTION
C		0 - INITIALIZE (allocates drive)
C		1 - READ
C		2 - WRITE
C	 	3 - RECORD SKIP
C		4 - REWIND
C		5 - WRITE EOF
C		6 - SKIP TO TAPE MARK
C		7 - OFFLINE REWIND
C	IERR - ERROR RETURN
C	       -1 - END OF FILE
C		0 - NO ERROR
C		1 - INVALID ICTL
C		2 - WRITE LOCK (NO WRITE RING)
C		3 - END OF TAPE
C		4 - RECORD LENGTH ERROR (DATA OVERRUN)
C		5 - NO VOLUME MOUNTED AND ON LINE OR VOLUME INVALID
C		6 - FATALS:
C			CONTROLLER ERROR,DATA CHECK,DRIVER ERROR,FORMAT
C			NONEXISTENT DRIVER,PARITY ERROR,DRIVE UNSAFE
C	KNT - NO. BYTES TO TRANSFER FOR READ AND WRITE OPERATIONS
C	    - +/- NO. FILES OR RECORD TO SKIP FOR SKIP OPERATIONS
C	IBUF - READ/WRITE BUFFER
C	IAMT - NO. BYTES TRANSFERED
C	     - NO. RECORDS ACTUALLY SKIPPED
C	     - NO. FILES ACTUALLY SKIPPED
C
	SUBROUTINE MTAPE(IUNIT,ICTL,IERR,KNT,IBUF,IAMT)
	IMPLICIT INTEGER*4 S
	INTEGER*2 IOPENZ(0:2)	!
	INTEGER*2 IOSB(4),MSGLEN
	INTEGER*4 IERR,FOURBYTE,ichan(3)
	CHARACTER*80 ERR_MSG
	DATA IOPENZ/0,0,0/	!
	INCLUDE 'IODEF.FOR'
	INCLUDE 'SSDEF.FOR'
	CALL ASSIGN(20,'SYS$OUTPUT')
	IERR=0
	IF(ICTL.EQ.0
	1 .OR.IOPENZ(IUNIT).EQ.0	!
	2 ) then
		IOPENZ(IUNIT)=1	!
	    if (iunit .eq. 0) then
		IERR=SYS$ASSIGN('_MTA0:',ICHAN(1),,)
		IF(.NOT.IERR) THEN
		   WRITE (20,1001)'NO CHANNEL ASSIGNED FOR MTA0:'
		   GOTO 9999
		ENDIF
	    endif
	    if (iunit .eq. 1) then
		IERR=SYS$ASSIGN('_MTB0:',ICHAN(2),,)
		IF(.NOT.IERR) THEN
		   WRITE (20,1001)'NO CHANNEL ASSIGNED FOR MTB0:'
		   GOTO 9999
		ENDIF
	    endif
	    if (iunit .eq. 2) then
		IERR=SYS$ASSIGN('_MTB1:',ICHAN(3),,)
		IF(.NOT.IERR) THEN
		   WRITE (20,1001)'NO CHANNEL ASSIGNED FOR MTB1:'
		   GOTO 9999
		ENDIF
	    endif
	    IF (ICTL.EQ.0) return
	endif
	IF(ICTL.LT.0.OR.ICTL.GT.7) THEN
		IERR=1
		RETURN
	END IF
	GOTO (10,20,30,40,50,60,70) ICTL
C	%%%%%%%%   READ   %%%%%%%%
10	ISYS=SYS$QIOW(,%VAL(ICHAN(iunit+1)),%VAL(IO$_READVBLK),
	1   IOSB,,,IBUF,%VAL(KNT),,,,)
	IF (ISYS .NE. SS$_NORMAL) IOSB(1)=ISYS
	CALL SETETC(IOSB,IERR,IAMT,ICTL)
	RETURN
C	%%%%%%%%   WRITE   %%%%%%%%
20	ISYS=SYS$QIOW(,%VAL(ICHAN(iunit+1)),%VAL(IO$_WRITEVBLK),
	1   IOSB,,,IBUF,%VAL(KNT),,,,)
	IF (ISYS .NE. SS$_NORMAL) IOSB(1)=ISYS
	CALL SETETC(IOSB,IERR,IAMT,ICTL)
	RETURN
C	%%%%%%%%   RECORD SKIP   %%%%%%%%
30	ISYS=SYS$QIOW(,%VAL(ICHAN(iunit+1)),%VAL(IO$_SKIPRECORD),
	1   IOSB,,,%VAL(KNT),,,,,)
	IF (ISYS .NE. SS$_NORMAL) IOSB(1)=ISYS
	CALL SETETC(IOSB,IERR,IAMT,ICTL)
	RETURN
C	%%%%%%%%   REWIND   %%%%%%%%
40	isys=SYS$QIOW(,%VAL(ICHAN(iunit+1)),%VAL(IO$_REWIND),
	1   IOSB,,,,,,,,)
	IF (ISYS .NE. SS$_NORMAL) IOSB(1)=ISYS
	CALL SETETC(IOSB,IERR,IAMT,ICTL)
	RETURN
C	%%%%%%%%   WRITE EOF   %%%%%%%%
50	isys=SYS$QIOW(,%VAL(ICHAN(iunit+1)),%VAL(IO$_WRITEOF),
	1   IOSB,,,,,,,,)
	IF (ISYS .NE. SS$_NORMAL) IOSB(1)=ISYS
	CALL SETETC(IOSB,IERR,IAMT,ICTL)
	RETURN
C	%%%%%%%%   SKIP FILE   %%%%%%%%
60	isys=SYS$QIOW(,%VAL(ICHAN(iunit+1)),%VAL(IO$_SKIPFILE),
	1   IOSB,,,%VAL(KNT),,,,,)
	IF (ISYS .NE. SS$_NORMAL) IOSB(1)=ISYS
	CALL SETETC(IOSB,IERR,IAMT,ICTL)
	RETURN
C	%%%%%%%%   REWIND OFFLINE   %%%%%%%%
70	isys=SYS$QIOW(,%VAL(ICHAN(iunit+1)),%VAL(IO$_REWINDOFF),
	1   IOSB,,,,,,,,)
	IF (ISYS .NE. SS$_NORMAL) IOSB(1)=ISYS
	CALL SETETC(IOSB,IERR,IAMT,ICTL)
	RETURN
C
C	FATAL ERROR MESSAGE GENERATOR
9999	CALL SYS$GETMSG(%VAL(IERR),MSGLEN,ERR_MSG,%VAL(15),FOURBYTE)
	WRITE (7,1001)ERR_MSG(1:MSGLEN)
1001	FORMAT (1X,A)
	WRITE (7,1002)ICTL
1002	FORMAT (' ICTL =',I6)
	close(20)
	RETURN
	END
C
C	SETETC - CALLS ERROR SET ROUTINE, SETS IAMT, AND CLOSES TT: OUTPUT
C
	SUBROUTINE SETETC(IOSB,IERR,IAMT,ICTL)
	IMPLICIT INTEGER*4 S
	INTEGER*2 IOSB(4)
	CALL IERRST(IOSB(1),IERR)
	IF(ICTL.LE.2) THEN
	  IAMT=IOSB(2)
	  IF(IAMT.LT.0) IAMT=IAMT+65536
	END IF
	RETURN
	END
C
C	IERRST - SETS IERR VALUE AND DISPLAYS MESSAGE TO TT:
C
	SUBROUTINE IERRST(I,IERR)
	IMPLICIT INTEGER*4 S
	INTEGER*2 I
	INCLUDE 'IODEF.FOR'
	INCLUDE 'SSDEF.FOR'
	IF(I.EQ.SS$_ENDOFFILE) THEN
		IERR=-1
		CALL ASSIGN(20,'SYS$OUTPUT')
		WRITE(20,5)
5		FORMAT(' END OF FILE ')
		close(20)
		RETURN
	endif
	IF(I.EQ.SS$_NORMAL) THEN
		IERR=0
		RETURN
	endif
	CALL ASSIGN(20,'SYS$OUTPUT')
	IF(I.EQ.SS$_WRITLCK) THEN
		IERR=2
		WRITE(20,10)
10		FORMAT(' WRITE LOCK ')
		goto 200
	ELSE IF(I.EQ.SS$_ENDOFTAPE) THEN
		IERR=3
		WRITE(20,15)
15		FORMAT(' END OF TAPE ')
		goto 200
	ELSE IF(I.EQ.SS$_ENDOFVOLUME) THEN
		IERR=3
		WRITE(20,15)
		goto 200
	ELSE IF(I.EQ.SS$_DATAOVERUN) THEN
		IERR=4
		WRITE(20,20)
20		FORMAT(' DATA OVERRUN ')
		goto 200
	ELSE IF(I.EQ.SS$_VOLINV) THEN
		IERR=5
		WRITE(20,25)
25		FORMAT(' INVALID VOLUME ')
		goto 200
	ELSE IF(I.EQ.SS$_MEDOFL) THEN
		IERR=5
		WRITE(20,30)
30		FORMAT(' OFFLINE ')
		goto 200
	ELSE IF(I.EQ.SS$_CTRLERR) THEN
		IERR=6
		WRITE(20,35)
35		FORMAT(' CONTROLLER ERROR ')
		goto 200
	ELSE IF(I.EQ.SS$_DATACHECK) THEN
		IERR=6
		WRITE(20,40)
40		FORMAT(' DATA CHECK ')
		goto 200
	ELSE IF(I.EQ.SS$_DRVERR) THEN
		IERR=6
		WRITE(20,45)
45		FORMAT(' DRIVER ERROR ')
		goto 200
	ELSE IF(I.EQ.SS$_FORMAT) THEN
		IERR=6
		WRITE(20,50)
50		FORMAT(' FORMAT ERROR ')
		goto 200
	ELSE IF(I.EQ.SS$_NONEXDRV) THEN
		IERR=6
		WRITE(20,55)
55		FORMAT(' NONEXISTENT DRIVER ')
		goto 200
	ELSE IF(I.EQ.SS$_PARITY) THEN
		IERR=6
		WRITE(20,60)
60		FORMAT(' PARITY ERROR ')
		goto 200
	ELSE IF(I.EQ.SS$_UNSAFE) THEN
		IERR=6
		WRITE(20,65)
65		FORMAT(' DRIVE UNSAFE ')
		goto 200
	ELSE IF (I .EQ. SS$_NOPRIV) THEN
		IERR=6
		WRITE (20,70)' No Priveledge '
 70		format (x,a)
		goto 200
	ELSE IF (I .EQ. SS$_ILLIOFUNC) THEN
		IERR=6
		WRITE (20,70)' Illegal I/O Function'
		goto 200
	ELSE
		WRITE (20,75)'Unknown Error, Code = ',I
 75		format (x,a,z8)
		goto 200
	END IF
200	close(20)
	return
	END

